'*****BEAUFORT V1.2
'Verbesserungen: 15 sekndiger Mittelwert fr  m/s, km/h,BFT Ausgabe
'FOM angepasst auf 3 (vorher 4)
'nach 9 Std. wird der letzte Gesamt-Wind-Mittelwert bernommen
'Tendenzberechnung und FOM bekommen sekndliche Werte
'Spannungsfehlerkompensation

$regfile = "m8def.dat"
'$crystal = 3686400
$crystal = 4000000                                          'Interner OSC mit 4MHz wird benutzt
$baud = 9600
$hwstack = 32
$swstack = 16
$framesize = 16
Declare Function Beaufort(wind As Single) As Integer
Declare Function Tendenz(wind As Single , Zaehler As Integer) As String
Declare Function Forecast(mittelwert1 As Single , Mittelwert2 As Single) As String
Declare Function Fom(spannung As Single , Zaehler As Integer) As Single
Dim Sfq As Single
Dim Wind_v As Single
Dim Wind_vtemp As Single
Dim Spannung As Single
Dim Spannungtemp As Single
Dim Kmh As Single
Dim Windstaerke As Integer
Dim Zaehler As Integer
Dim Anzeige As Byte
Dim Adcvalue As Word
Dim Adctemp As Word
Dim Adccomp As Word
Dim Tendenzanzeige As String * 8
Dim Lbytea As Byte
Dim Lworda As Word
Config Adc = Single , Prescaler = Auto                      ', Reference = Aref
Config Lcd = 16 * 2                                         'LCD 16x2 konfigurieren
Config Lcdpin = Pin , Db4 = Portb.5 , Db5 = Portb.4 , Db6 = Portb.3 , Db7 = Portb.2 , E = Portb.1 , Rs = Portb.0
Anzeige = 0
Zaehler = 1
Lbytea = 1                                                  'Zaehler/Laufvariable initialisieren
Lworda = 0
Config Portd.6 = Output
Config Portd.7 = Output
Portd.6 = 1                                                 'beide LEDs abschalten, PINs auf Hi
Portd.7 = 1
'----------------Hauptprogramm--------------------------------------------------------
Cls                                                         'Begrssungsbild auf LCD und RS232
Upperline
Lcd "m/s zu Beaufort"
Lowerline
Lcd "(c)2005 M.Meise"
Print "m/s zu Beaufort"
Print "(c)2005 M.Meise"
Wait 5
Do
Start Adc
Adctemp = Getadc(0)                                         'ADC auslesen Pin PC0
Waitms 10
Stop Adc                                                    'ADC-Spannungsfehlerkompensation
Adccomp = 1
Adctemp = Adctemp - Adccomp                                 'Erzeugung von temporren Variablen fr
Spannungtemp = Adctemp / 1023                               'die sekndliche Berechnung von FOM und Tendenz
Sfq = Fom(spannungtemp , Zaehler)                           'FOM ermitteln
Spannungtemp = Spannungtemp * 5
Wind_vtemp = Adctemp / 1023
Wind_vtemp = Wind_vtemp * 60
Lworda = Lworda + Adctemp                                   'start 15 sekndige Mittelwertbildung fr m/s,
If Lbytea = 15 Then                                         'Km / H , Bft ber Den Adc -wert
   Lworda = Lworda / 15
   Lbytea = 1
   Adcvalue = Lworda
End If                                                      'Ende Mittelwertbildung
Lbytea = Lbytea + 1
Spannung = Adcvalue / 1023                                  'Spannungsermittlung fr Diagnosezwecke
Spannung = Spannung * 5
Wind_v = Adcvalue / 1023
Wind_v = Wind_v * 60                                        'OBERGRENZE FESTLEGEN  UeMax=60m/s
Kmh = Wind_v * 3.6                                          'km/h berechnen
Windstaerke = Beaufort(wind_v)                              'Ausgabevariablen
If Windstaerke >= 13 Then                                   'Maximal Bft 13 zulssig
   Windstaerke = 13
End If
Tendenzanzeige = Tendenz(wind_vtemp , Zaehler)
If Anzeige = 15 Or Anzeige = 0 Then                         'Ausgabe bei 0 und alle 15 Sekunden
   Cls
   Upperline
   Lcd Fusing(wind_v , "#.#") ; "m/s " ; Fusing(kmh , "#.") ; "km/h"       'Ausgabe der Windstaerke in m/s auf LCD
   Lowerline
   Lcd "Bft: " ; Windstaerke ; " " ; Tendenzanzeige         'Ausgabe der Windstaerke in Beaufort auf LCD
   Anzeige = 1
End If
Print "Zaehler: " ; Zaehler
Print Fusing(wind_v , "#.#") ; " m/s   " ; Fusing(kmh , "#.") ; " km/h"       'Daten auf RS232
Print "Beaufort: " ; Windstaerke ; "   " ; Tendenzanzeige   'Ausgabe der Windstaerke in Beaufort auf RS232
Print "Spannung: " ; Fusing(spannungtemp , "#.###") ; " Volt"       'Spannungsausgabe auf RS232 sekndlich
Print "FOM: " ; Sfq                                         'sekndlich
Print " "
Anzeige = Anzeige + 1
Zaehler = Zaehler + 1
If Zaehler >= 32400 Then                                    'Zaehler fr 9 Stunden
   Zaehler = 1
   Portd.6 = 1                                              'beide LEDs abschalten, PINs auf Hi
   Portd.7 = 1
End If
Waitms 915
Loop
' --------------ENDE Hauptprogramm-----------------------------------------------------------------
Function Beaufort(wind As Single) As Integer                'Funktion Umrechnung in Beaufort
  Dim Ws As Single
  Dim Tmp As Single
  Dim Wsi As Integer
  Ws = Wind                                                 ' / 3.6 fr km/h
  Ws = Ws - 0.07
  Ws = Ws / 0.834
  Ws = Ws * Ws
  Ws = Log(ws)
  Tmp = Log(10)
  Ws = Ws / Tmp
  Ws = Ws / 3
  Tmp = 10
  Ws = Power(tmp , Ws)
  Ws = Round(ws)
  Wsi = Int(ws)
  Beaufort = Wsi
End Function
'---------------------------------------------------------------------------------------------------------
Function Tendenz(wind As Single , Zaehler As Single) As String       'Funktion Bestimmung der Tendenz
  Dim Mittelwert1 As Single
  Dim Mittelwert2 As Single
  Dim Accu As Single
  Dim Linta As Byte
  Dim Lintb As Integer
  If Zaehler >= 32400 Then                                  'nach 9 Std. Accu auf 0 setzen
      Accu = 0
  End If
  Accu = Accu + Wind
  Accu = Round(accu)
  If Zaehler = 1 Then
      Lintb = 0
      Mittelwert1 = Accu                                    '1-Sekundenwert
  End If
  If Zaehler = 60 Then                                      '1-Minutenwert
      Mittelwert2 = Accu / 60
      Mittelwert2 = Round(mittelwert2)
      Tendenz = Forecast(mittelwert1 , Mittelwert2)
      Mittelwert1 = Mittelwert2
  End If
  If Zaehler = 180 Then
      Portd.6 = 0                                           '1. LED nach 3 Minuten einschalten
  End If
  If Zaehler = 900 Then                                     '15 mintige Wertedarstellung
      Lintb = 900
  End If
  If Zaehler = Lintb Then
  Linta = 1
  Lintb = Lintb + 900
   If Linta >= 1 Then
      Mittelwert2 = Accu / Zaehler                          'Vergleich der 30 Minuten mit
      Mittelwert2 = Round(mittelwert2)                      'den vergangenen 15 Minuten usw.
      Tendenz = Forecast(mittelwert1 , Mittelwert2)
      Mittelwert1 = Mittelwert2
      Linta = 0
   End If
  End If
End Function
'-------------------------------------------------------------------------------------------------------------
Function Fom(spannung As Single , Zaehler As Integer) As Single       'Bestimmung der FOM
Dim Summedaten As Single
Dim Summequadrate As Single
Dim Temp1 As Single
Dim Temp2 As Single
Dim Squadrate As Single
Dim Lintx As Integer
Dim Linty As Bit
Dim Lintzaehler As Integer
If Zaehler >= 32400 Then                                    'Allgemeiner Reset nach 9 Stunden
   Summedaten = 0
   Summequadrate = 0
   Squadrate = 0
   Lintx = 0
   Linty = 0
   Lintzaehler = 0
End If
Select Case Zaehler
   Case Is = 300 : Lintx = 300                              'nach 5Minuten FOM Starten
   Case Is < 300
   Linty = 0
   Fom = 0
End Select

If Zaehler = Lintx Then                                     'alle 30 Minuten FOM neu starten
   Linty = 1
   Lintx = Lintx + 1800
   Summedaten = 0
   Summequadrate = 0
   Squadrate = 0
   Lintzaehler = 1
End If
If Linty = 1 Then                                           ' Hier wird FOM berechnet
   Squadrate = Spannung * Spannung                          'Spannung^2
   Summequadrate = Summequadrate + Squadrate                'Summe der Spannungen^2
   Summedaten = Summedaten + Spannung                       'Summe aller Spannungen
   Temp1 = Summedaten * Summedaten                          'Summe aller Spannungen^2
   Temp2 = Temp1 / Lintzaehler
   Fom = Summequadrate - Temp2                              'Summe der Fehlerquadrate
   If Fom > 3 Then
      Portd.7 = 1
   Else                                                     '2. LED ausschalten wenn FOM >3
      Portd.7 = 0                                           'sonst 2. LED einschalten
   End If
   Lintzaehler = Lintzaehler + 1
End If

End Function
'-------------------------------------------------------------------------------------------------------------
Function Forecast(mittelwert1 As Single , Mittelwert2 As Single) As String       ' Funktion Ausgabe
Select Case Mittelwert1
       Case Is < Mittelwert2 : Forecast = "Steigend"        'Ausgabe bestimmen
       Case Is > Mittelwert2 : Forecast = "Fallend"
       Case Is = Mittelwert2 : Forecast = "Stabil"
End Select
End Function
'-------------------------------------------------------------------------------------------------------------
End                                                         'end of program